Redmine - Defect #9821

Rake db fails updating from 1.2.1 to 1.3.0
2011-12-16 08:28 - pasquale [:dedalus]

Status: Closed Start date:

Priority: High Due date:

Assignee: % Done: 0%
Category: Database Estimated time: 0.00 hour
Target version:

Resolution: Invalid Affected version: 1.3.0
Description

Exec command => rake db:migrate RAILS_ENV=production fails with this message

Please install RDoc 2.4.2+ to generate documentation.
== CreateChangesetParents: migrating

—-— create_table (:changeset_parents, {:id=>false})
rake aborted!
An error has occurred, all later migrations canceled:

Mysgl: :Error: Table 'changeset_parents' already exists: CREATE TABLE "~ changeset_parents’ (' changes
et_id® int(11) NOT NULL, "parent_id’ int (11) NOT NULL) ENGINE=InnoDB

History

#1 - 2011-12-16 09:11 - Etienne Massip

--trace to get the failing migration?

#2 - 2011-12-16 09:25 - pasquale [:dedalus]
- File rakeDb--trace.log added

attached rakeDb woth trace log

#3 - 2011-12-16 10:39 - Etienne Massip

If the changeset_parents table did exist in the database before source:/tags/1.3.0/db/migrate/20110902000000_create_changeset_parents.rb was
started, then it might have been created by a plugin or maybe did you update the schema_migrations table by hand?

Else, could you please drop the schema_migrations table contents here?

#4 - 2011-12-16 12:12 - pasquale [:dedalus]
- File schema_migrations.log added
Etienne Massip wrote:

If the changeset_parents table did exist in the database before source:/tags/1.3.0/db/migrate/20110902000000_create_changeset_parents.rb
was started, then it might have been created by a plugin

| have backuped my db from 1.2.1 release and restored on 1.3.0: this table on my db don't exists.
Executing rake db command | have the error (no plugins installed).

If | execute the same command on new fresh db | haven't the error. But in the new db schema the new table changeset_parents exists, in the
previous db schema no: maybe it's this the problem?

you update the schema_migrations table by hand?

No

Else, could you please drop the schema_migrations table contents here?

schema_migrations.log

2025-07-02 1/4



https://www.redmine.org/projects/redmine/repository/svn/entry/tags/1.3.0/db/migrate/20110902000000_create_changeset_parents.rb
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/1.3.0/db/migrate/20110902000000_create_changeset_parents.rb
https://www.redmine.org/attachments/6940

#5 - 2011-12-16 23:01 - Hannes Meier

i ran into the same issue today from 1.2.2 to 1.3 using the 1.3 bitnami stack and just doing a cleandb > dbbackup.
Anyway 1.3 is running without problems with my old db.
Can i go with that or may i run into problems?

#6 - 2011-12-21 11:58 - Jure Klancar

| have same issue upgrading DB 1.2.1 (bitnami stack) in test environment.
Nevertheless, as Hannes, | can start new version withoout problems.
So | ask the same question: can | go with that?

#7 - 2011-12-22 09:58 - Ah Kow Tan

Same error when updating from 1.2.1 to 1.3

#8 - 2011-12-22 10:44 - Etienne Massip

I don't get it, why would this changeset_parents table already be there at the time this migration is ran?

Do you use some plugin that could have created it?

#9 - 2011-12-28 15:43 - Gonzalo Fernandez-Victorio

| have been able to reproduce the same error with this sequence.

1.-Install Bithami Redmine 1.3.0-1
2.-Restore backup of a Redmine previous version (I'm not sure, but | think it's 1.1.0)
3.-Invoking rake db:migrate

Obviously it was a mistake on my part: | should have drop and recreate the database entirely before step 2. | don't know if other people had the same
problem. Hannes Meier seems to say he did clean the database, so maybe his error is different.

For those with the error and asking if it's OK, | understand they won't be able to upgrade to a future version until they fix their setup. In case the
problem is similar to mine, the simplest fix could be to drop table, and relaunch rake.

#10 - 2011-12-29 02:38 - Ah Kow Tan

Gonzalo Fernandez-Victorio wrote:
| have been able to reproduce the same error with this sequence.

1.-Install Bitnami Redmine 1.3.0-1
2.-Restore backup of a Redmine previous version (I'm not sure, but | think it's 1.1.0)
3.-Invoking rake db:migrate

Obviously it was a mistake on my part: | should have drop and recreate the database entirely before step 2. | don't know if other people had the
same problem. Hannes Meier seems to say he did clean the database, so maybe his error is different.

For those with the error and asking if it's OK, | understand they won't be able to upgrade to a future version until they fix their setup. In case the
problem is similar to mine, the simplest fix could be to drop table, and relaunch rake.

Thanks, using Bitnami Redmine 1.3.0-1 too.
Here's what | do:

1. Backup previous version of Bitnami Redmine (1.2.1), including mysql database and file attachments.
2. Uninstall previous version of Bitnami Redmine

3. Install Bitnami Redmine 1.3.0-1

4. Restore mysql database

5. Run this command: rake db:migrate RAILS_ENV=production

6. Rake failed with this error: Table 'changeset_parents' already exists

7.Then | did these:

C:\Program Files\BitNami Redmine Stack\apps\redmine>mysgl -u bitnami -p bitnami_redmine
Enter password: ****

Welcome to the MySQL monitor. Commands end with ; or \g.

Your MySQL connection id is 10

Server version: 5.0.83-community MySQL Community Edition (GPL)

Type 'help;' or '\h' for help. Type '\c' to clear the current input statement.

mysgl> drop table changeset_parents;
Query OK, 0 rows affected (0.03 sec)
mysqgl> commit;

Query OK, 0 rows affected (0.00 sec)
mysqgl> quit

Bye

C:\Program Files\BitNami Redmine Stack\apps\redmine>rake db:migrate RAILS_ENV=production
CreateChangesetParents: migrating
create_table (:changeset_parents, {:id=>false})
-> 0.1092s

add_index (:changeset_parents,

b

[:changeset_id], {:unique=>false, :name=>:changeset_parents_changeset_ids
-> 0.2184s
add_index (:changeset_parents,
-> 0.2184s

= CreateChangesetParents:

[:parent_id], {:unique=>false, :name=>:changeset_parents_parent_ids})

(0.5460s)

migrated

C:\Program Files\BitNami Redmine Stack\apps\redmine>rake db:migrate:upgrade_plugin_migrations RAILS_ENV=pr
oduction
Cannot find old migration table - assuming nothing needs to be done

C:\Program Files\BitNami Redmine Stack\apps\redmine>rake db:migrate_plugins RAILS_ENV=production
Migrating
Migrating

engines...
acts_as_activity_provider...
acts_as_attachable...
acts_as_customizable...

Migrating
Migrating

Migrating acts_as_event...
acts_as_list...
acts_as_searchable. ..

acts_as_tree...

Migrating
Migrating
Migrating
acts_as_versioned...
acts_as_watchable. ..
awesome_nested_set...

Migrating
Migrating
Migrating
Migrating
Migrating
Migrating

classic_pagination...
gravatar...

Migrating
Migrating
Migrating

rfpdf...
ruby-net-1dap-0.0.4...

C:\Program Files\BitNami Redmine
C:\Program Files\BitNami Redmine

C:\Program Files\BitNami Redmine

prepend_engine_views...

open_id_authentication...

Stack\apps\redmine>rake tmp:cache:clear
Stack\apps\redmine>rake tmp:sessions:clear

Stack\apps\redmine>

Can that be considered an successful upgrade?
So far the new Redmine seems to be working fine.

#11 - 2012-01-02 23:12 - Etienne Massip

Ah Kow Tan wrote:

Can that be considered an successful upgrade?

Kind of, yes. But if this table was created by a plugin, then this plugin might not work as expected anymore (but btw it is not compatible with 1.3).

#12 - 2012-01-03 02:23 - Ah Kow Tan

Etienne Massip wrote:

Ah Kow Tan wrote:

Can that be considered an successful upgrade?

Kind of, yes. But if this table was created by a plugin, then this plugin might not work as expected anymore (but btw it is not compatible with 1.3).

Thanks, | did not install any plugin, unless Bitnami does. | also couldn't find any changeset_parents in my Redmine 1.2.1 mysgl dump.

Are those thing in C:\Program Files\BitNami Redmine Stack\apps\redmine\vendor\plugins considered plugins? My Administration -> Plugins

says No data to display.
Anyway, so far my Redmine 1.3 is still so good.

#13 - 2012-01-04 08:48 - pasquale [:dedalus]

Etienne Massip wrote:

But if this table was created by a plugin

This table isn't created by plugin (see my comment 4): before | restore my database from 1.2.1 to 1.3.0, browsing into him tho find this table produce
0 results: the table don't exists. After | restore db into 1.3.0 and then execute rake-db command, | have this error. It seems that we have some wrong

in rake-db...
#14 - 2012-01-04 11:22 - pasquale [:dedalus]
pasquale [:dedalus] wrote:

This table isn't created by plugin (see my comment 4)

To be more explicit:

1.redmine db 1.2.1 haven't table changeset_parents;
2.install new redmine 1.3.0 release with an empty new db;
3. restoring db 1.2.1 in new redmine environment;

4. execute rake-db command and this command fails because table changeset_parents already exists.

The problem is that in table migrations of db 1.2.1, isn't 20110902000000 value related to changeset_parents creation.

Restoring db 1.2.1 over new empty db 1.3.0, let migrations table unchanged (without 20110902000000 value) and let changeset_parents table in

restored db.

In this situation, the rake-db command fails per incongruence between migrations table and restored db.

To solve this situation:

1. Install new redmine enviroment 1.3.0;

2.drop new empty db 1.3.0

3.restore db 1.2.1 in new environment:

4. execute rake-db command and all is fine;
Etienne, this behavior isn't a redmine bug?
#15 - 2012-01-04 12:19 - Etienne Massip

No, it is not.

Now | understand why the table existed before:

e you created a fresh bare 1.3 DB with its schema which is useless since it should be overwritten by the DB import
¢ you made a full DB import over an existing base without replacing existing schema objects so the tables new in 1.3 remain

The upgrade process as described in RedmineUpgrade does not require any new DB creation?!

#16 - 2012-01-04 12:46 - pasquale [:dedalus]

Etienne Massip wrote:

No, it is not.

Then we can close it as invalid because redmine works as expected

#17 - 2012-01-04 13:28 - Etienne Massip
- Status changed from New to Closed

- Resolution set to Invalid

Files

rakeDb--trace.log 5.75 KB 2011-12-16 pasquale [:dedalus]

schema_migrations.log 2.53 KB 2011-12-16 pasquale [:dedalus]
2025-07-02 4/4


https://www.redmine.org/projects/redmine/wiki/RedmineUpgrade
